*
*  cursfunc.prg
*
*  UDFs to position the cursor via arrow keys, toggle
*  cursor on/off, and change cursor size.
*
*  Requires QuickSilver or dBXL, 1.2 or 1.3
*
*  The included program (demo.prg) demonstrates a procedure for
*  simulating some of the functions normally associated with a
*  mouse by using the keyboard arrow keys.
*
*  Cursor movement will be probably be sluggish under dBXL,
*  but should be ok for debugging.   For maximum dBXL speed,
*  try stripping out the comments and blank lines.
*
*  Phil Hill
*  Gainesville, FL
*  Jan. 2, 1990
******************
******************
FUNCTION rodent
*-- The function rodent() is responsible for moving the
*   simulated mouse cursor around the screen, and it returns
*   the last key pressed.

PRIV k, void

*-- Initial cursor position.
*   g_row, and g_col must have been initialized
*   by the calling program
@ M->g_row, M->g_col SAY ""

*-- Need a big cursor for visibility.
void = cursbig()

*-- k holds the keypress
*   initialize it here to execute the loop at least once
k = 0
DO WHILE M->k <> 27       && do while <Esc> not pressed
   k = 0
   DO WHILE M->k = 0
      *-- Check for a keypress.
      k = inkey()
   ENDDO
   DO CASE
      CASE M->k = 5 .AND. M->g_row > 0    && <Up>
           g_row = M->g_row - 1
      CASE M->k = 24 .AND. M->g_row < 24  && <Dn>
           g_row = M->g_row + 1
      CASE M->k = 19 .AND. M->g_col > 0   && <Left>
           g_col = M->g_col - 1
      CASE M->k = 4 .AND. M->g_col < 79   && <Right>
           g_col = M->g_col + 1
      CASE M->k = 13 .OR. M->k = 32       && <Enter> or <Spacebar>
           EXIT
   ENDCASE
   *-- Display the cursor at the new position.
   @ M->g_row, M->g_col SAY ""
ENDDO

*-- Restore a normal cursor.
void = curson()

*-- Return the last key pressed.
RETURN M->k
******************
******************
FUNCTION cursbig
*-- cursbig() creates a large block cursor.
*
PRIV ax, bx, cx
cx = iif(colrmode(), 263, 268)
ax = 256
bx = 0
DOSINT 16, ax, bx, cx
RETURN ""
******************
******************
FUNCTION curson
*-- curson() creates a standard cursor.
*
PRIV ax, bx, cx
cx = iif(colrmode(), 1543, 2828)
ax = 256
bx = 0
DOSINT 16, ax, bx, cx
RETURN ""
******************
******************
FUNCTION cursoff
*-- cursoff() turns the cursor off.
*
PRIV ax, bx, cx
cx = 8192
ax = 256
bx = 0
DOSINT 16, ax, bx, cx
RETURN ""
******************
******************
FUNCTION colrmode
*-- alternative to iscolor() - gives better results for cursor type
*   Returns .T. if running in color mode, .F. for mono - regardless
*   of hardware actually connected.
*
PRIV ax
ax = 3840
DOSINT 16, ax
RETURN (M->ax <> 20487)
******************
******************
* eof


