*
*  demo.prg
*
*  Demonstrates a procedure for simulating some of the functions
*  normally associated with a mouse, by using the keyboard arrow keys.
*
*  See cursfunc.prg for additional details.
*
******************
******************
SET confirm ON
SET scoreboard OFF
SET status OFF
SET escape OFF
SET bell OFF
SET udf TO cursfunc
void = cursoff()
CLEAR

*-- Initialize some fields.
a = "The first field"
b = "The second field"
c = "The third field"
d = "The fourth field"
e = "There could be more, of course."


*-- Initial display of the SAY/GET fields.
@ 2, 10 SAY "get # 1" GET a
@ 2, 40 SAY "get # 2" GET b
@ 4, 10 SAY "get # 3" GET c
@ 4, 40 SAY "get # 4" GET d
@ 7, 18 SAY "get # 5" GET e
CLEAR GETS

*-- Just some on-screen instructions.
@ 1, 8 TO 8, 65 DOUBLE
@ 12, 10 SAY 'Use the arrow keys to move the cursor to a field, then'
@ 13, 10 SAY '"click" <Spacebar> or <Enter> to edit.  <Esc> to quit.'

*-- Start at row = 0, column = 0
*   But, could really start anywhere - perhaps on the most
*   frequently edited field.
STORE 0 TO g_row, g_col

*-- Initial setting of exitkey, prior to the loop.
*   The function rodent() is responsible for moving the
*   simulated mouse cursor around the screen, and it returns
*   the last key pressed.
exitkey = rodent()

*-- This loop contains all of the "real" GET/READs.
*   The nested DO CASE structures will have to be hard-coded
*   with row/col ranges for each field.
DO WHILE M->exitkey <> 27   && do while <Esc> not pressed
   DO CASE
      CASE M->g_row = 2
           DO CASE
              CASE M->g_col >= 18 .AND. M->g_col <= 32
                   @ 2, 10 SAY "get # 1" GET a
                   READ
              CASE M->g_col >= 48 .AND. M->g_col <= 63
                   @ 2, 40 SAY "get # 2" GET b
                   READ
           ENDCASE
      CASE M->g_row = 4
           DO CASE
              CASE M->g_col >= 18 .AND. M->g_col <= 32
                   @ 4, 10 SAY "get # 3" GET c
                   READ
              CASE M->g_col >= 48 .AND. M->g_col <= 63
                   @ 4, 40 SAY "get # 4" GET d
                   READ
           ENDCASE
      CASE M->g_row = 7
           DO CASE
              CASE M->g_col >= 26 .AND. M->g_col <= 56
                   @ 7, 18 SAY "get # 5" GET e
                   READ
           ENDCASE
   ENDCASE
   *-- Time to move the cursor again.
   exitkey = rodent()
ENDDO

*-- All done.
CLEAR
RETURN
******************
******************
* eof

